// Session flags.
//
// $Id: session-flags.cc,v 1.1 1996/08/06 09:22:59 ceder Exp $
// Copyright (C) 1996  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "session-flags.h"
#include "prot-a-LyStr.h"

Session_flags::Session_flags()
  : df_invisible(false),
    df_user_active_used(false),
    df_user_absent(false)
{
}

bool
Session_flags::invisible() const
{
    return df_invisible;
}

bool
Session_flags::user_active_used() const
{
    return df_user_active_used;
}
bool
Session_flags::user_absent() const
{
    return df_user_absent;
}

Session_flags
parse_session_flags(prot_a_LyStr &prot_a_str)
{
    Session_flags res;

    prot_a_str.parse_bit(res.df_invisible);
    prot_a_str.parse_bit(res.df_user_active_used);
    prot_a_str.parse_bit(res.df_user_absent);
    prot_a_str.skip_bits();

    return res;
}
