// Static session information.
//
// $Id: static-session-info.h,v 1.2 1996/08/12 12:58:08 ceder Exp $
// Copyright (C) 1996  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef KOMXX_STATIC_SESSION_INFO_H
#define KOMXX_STATIC_SESSION_INFO_H

#include <time.h>

#include "kom-types.h"
#include "prot-a-LyStr.h"

class Static_session_info {
  public:
    Static_session_info();
    Static_session_info(const Static_session_info&);
    Static_session_info(prot_a_LyStr &prot_a_string);
    ~Static_session_info();

    const Static_session_info &operator =(const Static_session_info &);

    Kom_err  parse(prot_a_LyStr &prot_a_string);

    LyStr  user_name()           const;
    LyStr  hostname()            const;
    LyStr  ident_user()          const;
    struct tm connection_time()  const;
  private:
    LyStr   uname;
    LyStr   hname;
    LyStr   idusr;
    struct tm connect_tm;
};
#endif
