// Trinary logic.
//
// $Id: trinary.h,v 1.1 1996/07/09 11:53:12 ceder Exp $
// Copyright (C) 1996  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef KOMXX_TRINARY_H
#define KOMXX_TRINARY_H

class trinary {
  public:
    trinary();
    trinary(const trinary &);
    trinary(bool);
    ~trinary();

    trinary &operator = (const trinary &);
    trinary operator & (const trinary &);
    trinary operator | (const trinary &);
    trinary operator ^ (const trinary &);

    friend bool is_true(const trinary &);
    friend bool is_false(const trinary &);
    friend bool is_unknown(const trinary &);

  private:
    enum val {
	tri_false = 0,
	tri_true = 1,
	tri_unknown = 2
    } value;
    trinary(val);
};

#endif
