# Makefile template for WWW-kom
# $Id: Makefile.py,v 1.6 1996/09/08 16:58:51 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Process this file with python to generate Makefile.in.

from pmg import *

class htmldir_mixin(bindir_mixin):
    def destination(self):
	return "$(htmldir)"

class html_files(htmldir_mixin, collection_target):
    def __init__(self):
	self.name = "html"
	collection_target.__init__(self)

    def add(self, object):
	self.add_dep(nobuild_item(object))


class gif_files(htmldir_mixin, collection_target):
    def __init__(self):
	self.name = "gif"
	collection_target.__init__(self)

    def add(self, object):
	self.add_dep(nobuild_item(object))

m = komxxmakefile()

t = html_files()
t.add("index.html")
t.add("newuser.html")
t.add("nyheter.html")

m.add_target(t)

t = gif_files()
t.add("board-sv.gif")
t.add("board.gif")
t.add("comment-sv.gif")
t.add("comment.gif")
t.add("config-sv.gif")
t.add("config.gif")
t.add("exit-sv.gif")
t.add("exit.gif")
t.add("formatted-sv.gif")
t.add("formatted.gif")
t.add("home-sv.gif")
t.add("home.gif")
t.add("next-conf-sv.gif")
t.add("next-conf.gif")
t.add("next-text-sv.gif")
t.add("next-text.gif")
t.add("next-comment-sv.gif")
t.add("next-comment.gif")
t.add("next-footnote-sv.gif")
t.add("next-footnote.gif")
t.add("selconf-sv.gif")
t.add("selconf.gif")
t.add("time-sv.gif")
t.add("time.gif")
t.add("unformatted-sv.gif")
t.add("unformatted.gif")
t.add("write-sv.gif")
t.add("write.gif")

t.add("signum.gif")
t.add("signum-sv.gif")
t.add("wwwkom.gif")
t.add("wwwkom-sv.gif")

m.add_target(t)

m.emit()

print """\
# Where to install HTML files
htmldir = $(datadir)/wwwkom/$(VERSION)/html

# The generated gif files are distributed; they are small, and we
# don't want the users to have to compile netpbm just to be able to
# generate a few icons.  You can use this target to regenerate them.

gengifs: pnm3dmargin pnmbutton svbuttons.txt
	grep -v '^#' svbuttons.txt | grep -v '^[ \t]*$$' | ./pnmbutton
"""
