# $Id: language.py,v 1.47 1996/09/06 21:38:57 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string
import time
import komhtml
import log

anchor = komhtml.anchor

# Set by sc.  This module uses toolbar.at_top() and toolbar.at_bottom()
# to extract the tool bar.
toolbar = None

TEXT_FORMAT = """%(text_no)d %(creation_date)s /%(lines)s/ <b>%(author)s</b><br>
%(recipients)s%(uplinks)s%(marks)s
<h3>rende: %(subject)s</h3>
<hr noshade>
%(body)s
<hr noshade>
<p>%(footnotes)s%(comments)s
"""

CONVERSION_FORMAT = """Konvertering av text:<br>
<input type="radio" name="conversion"
    value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
    value="none" %(select_none)s>ingen<br>"""

WRITE_COMMENT_FORMAT = """Kommentera text %(parent_link)s %(parent_author)s
%(form)s
"""

WRITE_TEXT_FORMAT = """Skriva ett nytt inlgg i %(conf-name)s.
%(form)s
"""

WRITE_PRESENTATION_FORMAT = """Skriva en ny presentation av %(conf-name)s.
%(form)s
"""

WRITE_TEXT_FORM = """

<p><form action="submit_text" method="get">
<input type="hidden" name="known_comments" value="%(known_comments)s">
%(conversion)s
%(presentations)s
%(recipients)s
%(comments)s

<p><input type="submit" value="%(submit_text)s">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70">%(body)s</textarea>

<p><input type="submit" value="%(submit_text)s">
</form>
"""

SET_UNREAD_FORM = """
<form action="set_unread" method="get">
Hr kan du ndra antalet olsta texter i %(name_nolink)s.  Du kan
vlja att bara lsa inlgg som skrivits de senaste dagarna, eller att
bara lsa de senaste inlggen.
<p>
Antal inlgg: <input type="text" name="unread_texts" size=8><br>
Antal dagar: <input type="text" name="unread_days" size=8>
<input type="submit" value="ndra antal olsta">
<input type="hidden" name="conf_no" value="%(conf_no)d">
</form>
"""

CONFIGURATION_FORM = """

P den hr sidan kan du stlla in hur du vill att WWW-kom ska fungera.
Med tiden kommer fler och fler saker att g att pverka hr.  De
instllningar du gr sparas mellan sessionerna.

<form action="submit_configuration" method="get">

<h3>Bakgrundsfrg</h3>

Vill du att WWW-kom ska stta bakgrundsfrg p sidorna?<br>

<input type="radio" name="color" value="default" %(color-default)s>
Ja, anvnd vit bakgrund.<br>

<input type="radio" name="color" value="none" %(color-none)s>
Nej, lt min browser bestmma frgen.<br>

<h3>Konvertering swascii -> ISO 8859-1</h3>

De svenska tecknen "", "" och "" kan vara svra att mata in frn
viss utrustning.  Om du har lttare att mata in "}", "{" och "|" s
kan WWW-kom konvertera den text du skriver t dig nr du skapar
inlgg.  Tnk p att om du slr p den hr konverteringen s blir det
omjligt fr dig att skriva fljande tecken: "}{|][\\".

<p>Vill du att WWW-kom ska konvertera texter du skriver t dig?<br>

<input type="radio" name="entry-conversion" value="off" %(ec-off)s>
Nej, konvertera inte.<br>

<input type="radio" name="entry-conversion" value="ask-off" %(ec-ask-off)s>
Konvertera inte, men ge mjlighet att sl p konvertering varje gng
en text skrivs.<br>

<input type="radio" name="entry-conversion" value="ask-on" %(ec-ask-on)s>
Konvertera, men ge mjlighet att sl av konvertering varje gng
en text skrivs.<br>

<input type="radio" name="entry-conversion" value="on" %(ec-on)s>
Ja, konvertera alltid.

<h3>Navigeringslisten</h3>

Navigeringslisten r den list som finns lngst upp (och ibland lngst
ner) p varje sida, som du anvnder fr att bestmma vad du vill gra.
Den kan ha tre olika utseenden.  Vilket tycker du bst om?<br>

<input type="radio" name="looknfeel" value="default" %(lnf-default-checked)s>
Enkla knappar med text p, som ser ut s hr: %(lnf-default-demo)s<br>

<input type="radio" name="looknfeel" value="textonly" %(lnf-text-checked)s>
Enbart text.  Motsvarande knapp ser ut s hr: %(lnf-text-demo)s<br>

<input type="radio" name="looknfeel" value="sillyicons" %(lnf-silly-checked)s>
Frgglada, men ack s svrbegripliga, ikoner: %(lnf-silly-demo)s<br>

<h3>Begrnsa antal mten</h3>

Nr du vljer %(home-demo)s frn navigerinslisten visas normalt en
versiktssida med alla mten dr du har olsta texter.  Om det r
mnga mten kan det ta tid att f fram hela sidan.  Hr kan du
stta en maxstorlek p hur stor listan ska f vara.  Om det egentligen
finns fler mten med nyheter visas en text lngst ner som berttar
det.  Allt eftersom du lser inlggen kommer nya mten att visas i
listningen, tills du har frre olsta n den grns du stter hr.

<p>Om fltet r blankt eller "0" kommer det inte att finnas ngon
begrnsning.<br>

Grns: <input type="text" name="home-max-confs"
	size="10" value=\"%(home-max-confs)s">

<h3>Klickbara frfattare</h3>

Nr du vljer %(conf-demo)s frn navigerinslisten visas en
versiktssida med de olsta texter som finns i mtet.  Om man klickar
p textnumret eller renderaden fr en viss text fr man se den
texten.  Nr "klickbara frfattare" r p slaget kan man dessutom
klicka p frfattarna p den sidan.  Om man gr det fr man upp en
statussida fr frfattaren.<br>

<input type="radio" name="conf-authors-linked" value="off" %(cal-off-checked)s>
Ej klickbara frfattare.
<input type="radio" name="conf-authors-linked" value="on" %(cal-on-checked)s>
Klickbara frfattare.

<p><input type="submit" value="Spara instllningarna">
</form>
"""

WRITE_TEXT_NEW_COMMENTS = """\
Sedan du brjade frfatta din kommentar har det skapats minst en
ny kommentar.  gna igenom de nya texterna nedan.  Om du fortfarande
tycker att din kommentar r relevant kan du klicka p
"Skapa kommentaren"-knappen (lngst ner p sidan) fr att skicka in
texten igen.  Om du mrker att ngon annan redan har sagt det du hade
tnkt sga r det kanske ingen strre vits med att du upprepar samma
sak en gng till.  I s fall kan du g tillbaks och fortstta lsa.
<p>

<hr noshade><blockquote>
%(new_texts)s
</blockquote><hr>
%(form)s
"""

KILLED = """\
Din sessionshanterare r nu avslutad.  Du r utloggad ur LysKOM.
Observera dock att din WWW-klient troligtvis fortfarande innehller
ditt LysKOM-anvndarnamn och lsenord.  Fr att skerstlla att
ingen obehrigt anvnder LysKOM i ditt namn br du starta om din
WWW-klient innan du lmnar datorn.

<p>Du kan starta en ny session genom att vlja ngot av alternativen ovan.
"""

SELECT_CONF_FORM = """\
<form action="submit_select_conf" method=get>
Namn: <input type="text" name="conf_name" size=70>
<input type="submit" value="Sk"><br>
Vad ska matchas?<br>
<input type="radio" name="domain" value="conf" checked>Enbart mten<br>
<input type="radio" name="domain" value="pers">Enbart personer<br>
<input type="radio" name="domain" value="both">Bde personer och mten<br>
</form>

<p>I rutan efter "Namn" kan du fylla i ett mtes- eller personnamn.
Du kan frkorta namnet genom att utelmna ord p slutet, och genom att
utelmna bokstver p slutet i ord.  Om mer n ett mte matchar det
frkortade mtesnamnet du angivit kommer du att f upp en lista med
dem, dr du kan vlja rtt.

<p>Om du lmnar rutan tom kommer alla mten att returneras.  Det kan
ta ett bra tag.

<p>Du kan vlja om du vill ska bland mten, personer eller bde och.
"""

CONF_STAT = """\
Status fr mte "%(name)s":

<ul>%(creator)s
<li>Organisatr%(supervisor)s
<li>Tilltna frfattare: %(permitted_submitters)s
<li>Presentation: %(presentation)s
</ul>

%(join_or_member)s<br>
%(write_text_anchor)s<br>
%(set_unread_form)s
"""

class pages:
    def __init__(self):
	self.use_color = 1

    def page(self, title, header, body):
	if toolbar:
	    top_tool = toolbar.at_top()
	    bot_tool = toolbar.at_bottom()
	else:
	    top_tool = ""
	    bot_tool = ""
	body_tag = "<body>\n"
	if self.use_color:
	    body_tag = ('<body bgcolor="#ffffff" text="#000000"'
			+ ' link="#0000ee" vlink="551a8b" alink="ff0000">\n')
	return ("<html><head><title>" + self.title(title)
		+ "</title></head>\n"
		+ body_tag
		+ top_tool + "\n<h2>"
		+ header + "</h2>\n\n" + body + bot_tool + "\n\n"
		+ self.stdfoot() + "</body></html>")

    def color_mode(self, mode):
	if mode == "none":
	    self.use_color = 0
	elif mode == "default":
	    self.use_color = 1
	# Silently ignore bad modes.

class sw_pages(pages):
    def stdfoot(self):
	return ("<hr noshade><table><tr><td>"
		+ komhtml.icon("wwwkom", "WWW-koms hemsida", "/")
		+ komhtml.icon("signum", "Signum Support AB",
			       "http://www.signum.se/")
		+ '</td><td><font size=-1>Sidan genererad '
		+ self.format_date(time.localtime(time.time()))
		+ ' av WWW-kom.</font><br>\n'
		+ 'WWW-kom. Copyright  1996 Signum Support AB.</td></tr></table>\n')

    def title(self, t):
	return "LysKOM: " + t

    def ambiguous_login(self, given, matches):
	res="<ul>\n"
	for m in matches:
	    res = res + '<li>' + anchor(komhtml.komurl("login", m.conf_no()),
					komhtml.htmlquote(m.conf_name()))
	res = res + "</ul>\n\n"
	return self.page("Vem r du?", "Vem r du?",
			 "Det namn du angav, \"" + komhtml.htmlquote(given)
			 + "\", kan vara ngon av fljande personer:\n"
			 + res)

    def bad_password_for_session(self, given_user):
	return self.page("Fel lsen", "Felaktigt lsenord",
			 "Det lsenord du angav stmmer inte med "
			 + "lsenordet fr "
			 + given_user + '.  '
			 + anchor(komhtml.komurl("login"), "Frsk igen."))

    def nonexisting_person_url(self, given_number):
	return self.page("Felaktig URL", "Felaktig URL",
			 "Du har fljt en lnk som innehller en referens till"
			 + " person nummer " + `given_number`
			 + ". Det finns fr tillfllet ingen sdan anvndare. "
			 + anchor(komhtml.komurl("login"), "Frsk igen."))

    def noconnect(self):
	return self.page("Servern svarar inte", "LysKOM-servern svarar inte",
			 "LysKOM-servern kan inte ns.  Det kan bero p att "
			 + "servern r nere eller ngot ntverksproblem.  "
			 + "Frsk igen om en halvtimme.")

    def session_redirect(self, newurl):
	return self.page("Omstyrning", "Omstyrning",
			 "Din WWW-klient tycks inte frst felkod 301. Det "
			 + "innebr troligtvis att du inte kan anvnda den "
			 + "fr att lsa LysKOM med WWW-kom, men om du har "
			 + "tur kanske du kan anvnda WWW-kom genom att "
			 + anchor(newurl, "flja denna lnk"))

    def who_is_on(self, wholist):
	header = "<table border=0 cellpadding=3>"
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Inloggade i lyskom",
			 "Fljande personer r inloggade fr nrvarande",
			 header + wholiststring + footer)

    def who_is_on_conf(self, conf, wholist):
	header = ("Fljande personer r just nu nrvarande i "
		  + conf + "\n\n<table border=0 cellpadding=3>")
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Nrvarande i mte",
			 "Nrvarande i mte",
			 header + wholiststring + footer)

    def not_present(self):
	return "Ej nrvarande i ngot mte"

    def format_footnote(self, footnote, footnote_author):
	return ("Fotnot i text " + footnote + " " + footnote_author
		+ "<br>\n")

    def format_comment(self, comment, comment_author):
	return ("Kommentar i text " + comment + " " + comment_author
		+ "<br>\n")

    def format_date(self, date):
	return "%04d-%02d-%02d %02d:%02d:%02d" % date[0:6]
	return `date[0]` + "-" + `date[1]` + "-" + `date[2]` \
	       + " " + `date[3]` + ":" + `date[4]` + ":" + `date[5]`

    def format_uplink(self, is_footnote, parent_text, parent_author_name,
		      sent_at, sender_name):
	if is_footnote:
	    res = "Fotnot till text "
	else:
	    res = "Kommentar till text "
	res = res + parent_text + " " + parent_author_name + "<br>\n"
	if sent_at:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_at)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def undef_conf(self, conf_no):
	return "Person/mte nummer " + `conf_no` + " (existerar ej/hemlig)"

    def nonexisting_text(self):
	return " (ej lsbar av dig)"

    def nonexisting_text_long(self):
	return "Texten finns inte, eller ocks r den hemlig."

    def anonymous_author(self):
	return " (anonym frfattare)"

    def nonexistent_author(self, pers_no):
	return " (utplnad/hemlig frfattare nummer " + `pers_no` + ")"

    def by_author(self, author):
	return "av " + author

    def format_recipient(self, is_carbon_copy, name, local_no,
			 rec_time, sent_time, sender_name):
	if is_carbon_copy:
	    res = "Extra kopiemottagare "
	else:
	    res = "Mottagare "
	res = res + name + " &lt;" + `local_no` + "&gt;<br>\n"
	if rec_time:
	    res = (res + "&nbsp;&nbsp;Mottaget: " + self.format_date(rec_time)
		   + "<br>\n")
	if sent_time:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_time)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def text_rewrite_map(self, map):
	if map["lines"] == 1:
	    map["lines"] = "1 rad"
	else:
	    map["lines"] = `map["lines"]` + " rader"
	marks = map["num_marks"]
	if marks == 0:
	    map["marks"] = ""
	elif marks == 1:
	    map["marks"] = "Markerad av en person<br>\n"
	else:
	    map["marks"] = "Markerad av " + `marks` + " personer<br>\n"

	# FIXME
	map["default_url"] = "<i>Default-URL</i>"


    def alt_conf(self):
	return "Olsta i mtet"

    def explain_conf(self):
	return "Lista olsta inlgg i mtet"

    def alt_comment(self):
	return "Kommentera"

    def explain_comment(self, textno):
	return "Skriv en kommentar till text " + `textno`

    def alt_write_text(self):
	return "Skriv inlgg"

    def explain_write_text(self):
	return "Skriv inlgg"

    def alt_next_conf(self, cname):
	# FIXME: This might be too long.
	return "Nsta mte (" + cname + ")"

    def explain_next_conf(self, cname):
	return "G till nsta mte (" + cname + ")"

    def alt_see_time(self):
	return "Se tiden"

    def explain_see_time(self):
	return "Se tiden (enligt servern)"

    def alt_home(self):
	return "Hem"

    def explain_home(self):
	return "Lista mten med olsta texter"

    def alt_kill(self):
	return "Logga ut"

    def explain_kill(self):
	return "Avsluta WWW-kom"

    def alt_next_text(self, tno):
	return "Nsta text (" + `tno` + ")"

    def explain_next_text(self, tno):
	return "Lsa nsta text (" + `tno` + ")"

    def alt_unformatted(self):
	return "Lsa oformatterad"

    def explain_unformatted(self, tno):
	return "Lsa text " + `tno` + " igen, oformatterad"

    def alt_formatted(self):
	return "Lsa formatterad"

    def explain_formatted(self, tno):
	return "Lsa text " + `tno` + " igen, heuristiskt formatterad"

    def alt_config(self):
	return "ndra instllningar"

    def explain_config(self):
	return "Formulr fr att ndra personliga instllningar"

    def alt_next_comment(self, tno):
	return "Nsta kommentar (" + `tno` + ")"

    def explain_next_comment(self, tno):
	return "Lsa nsta kommentar (" + `tno` + ")"

    def alt_next_footnote(self, tno):
	return "Nsta fotnot (" + `tno` + ")"

    def explain_next_footnote(self, tno):
	return "Lsa nsta fotnot (" + `tno` + ")"

    def alt_select_conf(self):
	return "Lista mten"

    def explain_select_conf(self):
	return "Sk efter mte och visa info"

    def format_text(self, map):
	self.text_rewrite_map(map)
	return TEXT_FORMAT % map

    def info_unread_conf(self, conf, unread):
	if unread == 1:
	    return "1 olst i " + conf
	else:
	    return `unread` + " olsta i " + conf

    def there_are_more_unread_confs(self):
	return ("\n<p>\nDu har olsta inlgg i nnu fler mten. "
		+ "De kommer att visas nr du har lst ovanstende mten.")

    def login(self, unreadlist, trunc_msg, tot_unread):
	if trunc_msg == "":
	    if tot_unread == 1:
		trunc_msg = "\n\n<p>Du har totalt 1 olst text."
	    else:
		trunc_msg = ("\n\n<p>Du har totalt " + `tot_unread`
			     + " olsta texter.")
	return self.page("Vlkommen", "Vlkommen till LysKOM!",
			 "Du r nu inloggad. "
			 + "Du har olsta inlgg i fljande mten:\n<p>\n"
			 + unreadlist
			 + trunc_msg)

    def unread_confs(self, unreadlist, trunc_msg, tot_unread):
	if trunc_msg == "":
	    if tot_unread == 1:
		trunc_msg = "\n\n<p>Du har totalt 1 olst text."
	    else:
		trunc_msg = ("\n\n<p>Du har totalt " + `tot_unread`
			     + " olsta texter.")
	return self.page("Olsta mten", "Olsta mten",
			 "Du har olsta inlgg i fljande mten:\n<p>\n"
			 + unreadlist
			 + trunc_msg)

    def text_link(self, text, subject, prev_subject, author):
	if subject == prev_subject:
	    subject = "--"
	elif subject == "":
	    subject = "(rende saknas)"
	else:
	    subject = "<b>" + subject + "</b>"

	return (komhtml.text_as_link(text, subject + " (text " + `text` + ")")
		+ " " + author)

    def different_passwords(self):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "Du angav tv olika lsenord.  Frsk igen.")

    def person_creation_failed(self, name):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "En person med namnet " +name+ " kunde inte skapas.\n"
			 + "Kanske finns det redan ngon som heter s?\n\n"
			 + "<p>Frsk igen med ett annat namn.\n"
			 + "Du kan till exempel lgga till en initial "
			 + "eller namnet p din organisation.")

    def creation_done(self, name, pno):
	return self.page("WWW-kom", "Vlkommen",
			 "Vlkommen till LysKOM, " + komhtml.htmlquote(name)
			 + "!\nHoppas du ska trivas hr.\n"
			 + "Nu mste du "
			 + anchor(komhtml.komurl("login"), "logga in")
			 + ". "
			 + "Din Web-klient kommer att be dig mata in det namn "
			 + "och lsenord som du just angav.\n"
			 + "(Du tycker kanske att det r dumt att du ska "
			 + "behva mata in de uppgifterna igen.  Tyvrr "
			 + "tvingar HTTP fram den hr lsningen).\n\n"
			 + "<p>Om du r den sifferlskande typen vill du "
			 + "kanske veta att ditt anvndarnummer r " + `pno`
			 + ".  Annars kan du strunta i det -- du kan alltid "
			 + "anvnda ditt namn och behver inte komma ihg det "
			 + "nummer som anvnds internt i LysKOM-systemet.")

    def button_submit_text(self, presentations, footnotes, comments):
	if presentations > 0:
	    return "Skapa presentationen"
	elif footnotes > 0:
	    return "Skapa fotnoten"
	elif comments > 0:
	    return "Skapa kommentaren"
	else:
	    return "Skapa texten"

    def write_text_form(self, map):
	return WRITE_TEXT_FORM % map

    def write_comment(self, form, parent, parent_author):
	return self.page("Kommentera text " + parent,
			 "Kommentera text " + parent,
			 WRITE_COMMENT_FORMAT % {"parent_link": parent,
						 "parent_author":parent_author,
						 "form": form})

    def write_text(self, form, conference):
	return self.page("Skriva inlgg",
			 "Skriva inlgg i " + conference,
			 WRITE_TEXT_FORMAT % {"conf-name": conference,
					      "form": form})

    def write_presentation(self, form, conference):
	return self.page("Presentera " + conference,
			 "Skriva presentation fr " + conference,
			 WRITE_PRESENTATION_FORMAT % {"conf-name": conference,
						      "form": form})

    def conversion_format(self, map):
	return CONVERSION_FORMAT % map

    def write_text_format_recipient(self, conf, conf_as_link):
	return ('Mottagare: <input type="checkbox" name="rcpt'
		+ '" value="' + `conf` + '" checked> '
		+ conf_as_link + '<br>\n')

    def write_text_format_cc_recipient(self, conf, conf_as_link):
	return ('Extra kopie-mottagare: <input type="checkbox" name="cc_rcpt'
		+ '" value="' + `conf` + '" checked> '
		+ conf_as_link + '<br>\n')

    def write_text_format_recipient_part(self, recips):
	if len(recips) == 0:
	    return ""
	elif len(recips) == 1:
	    return recips[0]
	else:
	    return ("Texten du skriver har flera mottagare. "
		    + "Du kan ta bort mottagare genom att vlja bort dem."
		    + "<br>\n"
		    + string.joinfields(recips, ""))

    def write_text_format_comment(self, text, author):
	return ('<input type="checkbox" name="parent" value="'
		+ `text` + '" checked> Kommentar till text ' + `text`
		+ ' ' + author + '<br>\n')

    def write_text_format_footnote(self, text, author):
	return ('<input type="checkbox" name="parent_footnote" value="'
		+ `text` + '" checked> Fotnot till text ' + `text`
		+ ' ' + author + '<br>\n')

    def write_text_format_comments_part(self, comments):
	if len(comments) == 0:
	    return ""
	elif len(comments) == 1:
	    return comments[0]
	else:
	    return ("Texten du skriver r kommentar till flera texter. "
		    + "Du kan vlja bort en eller flera av dem.<br>"
		    + string.joinfields(comments, ""))

    def write_text_format_presentation(self, cno, cname):
	return ('<input type="checkbox" name="presentation_for" value="'
		+ `cno` + '" checked> Presentation fr ' + cname + '<br>\n')

    def write_text_format_presentations_part(self, presents):
	if len(presents) == 0:
	    return ""
	elif len(presents) == 1:
	    return presents[0]
	else:
	    return ("Texten du skriver r presentation till flera mten. "
		    + "Det r nog ovanligt att det r vettigt att ha samma "
		    + "text som presentation till flera mten -- du har vl "
		    + "koll p vad du gr nu? "
		    + "Du kan vlja bort en eller flera av dem.<br>"
		    + string.joinfields(presents, ""))
	

    def new_texts_exists(self, new_texts, form):
	new_texts = string.join(new_texts, "\n<hr>\n")
	return self.page("Nya kommentarer", "Nya kommentarer funna",
			 WRITE_TEXT_NEW_COMMENTS % {"new_texts": new_texts,
						    "form": form})

    def killed(self):
	return self.page("Omstart", "Omstart", KILLED)

    def select_conf_form(self):
	return self.page("Lista mten", "Lista mten", SELECT_CONF_FORM)

    def list_conf(self, matches):
	# FIXME: kan vara personer...
	res="<ul>\n"
	for item in matches:
	    res = (res + '<li>'
		   + komhtml.conf_as_link(item.conf_no(), item.conf_name())
		   + '\n')
	res = res + "</ul>\n\n"
	return self.page("Mten", "Mten",
			 "Fljande mten/personer matchar det du angav: <p>" 
			 + res)

    def conf_stat(self, session, map, currently_member):
	if not currently_member:
	    if map["join_allowed"]:
		map["join_or_member"] = anchor(map["join"], "G med i mtet")
	    else:
		map["join_or_member"] = (
		    "Du fr troligtvis inte g med i mtet, eftersom "
		    + "det inte r ppet. "
		    + anchor(map["join"], "Frsk g med nd."))
	    map["set_unread_form"] = ""
	else:
	    map["join_or_member"] = anchor(map["disjoin"], "Uttrda ur mtet")
	    map["set_unread_form"] = SET_UNREAD_FORM % \
				     {"name_nolink":map["name_nolink"],
				      "conf_no":map["conf_no"]}

	if map["supervisor"] == None:
	    map["supervisor"] = " saknas"
	else:
	    map["supervisor"] = ": " + map["supervisor"]

	if map["creator"] == None:
	    map["creator"] = ""
	else:
	    map["creator"] = "\n<li>Skapat av: " + map["creator"]

	map["write_text_anchor"] = anchor(map["write_text"],
					  "Skriv ett inlgg i mtet")

	return self.page(map["name_nolink"], map["name"], CONF_STAT % map)

    def create_presentation(self, url):
	return anchor(url, "Skapa presentation")

    def change_presentation(self, url):
	return anchor(url, "ndra presentationen")

    def no_presentation(self):
	return "saknas."
	
    def configuration(self, map):
	return self.page("ndra instllningar", "ndra instllningar",
			 CONFIGURATION_FORM % map)

lingo=sw_pages()
